Getting Started with the Vue Timeline Component in Vue 2

5 Mar 20267 minutes to read

This article provides a step-by-step guide for setting up a Vue 2 project using Vue-CLI and integrating the Syncfusion® Vue Timeline component.

Prerequisites

System requirements for Syncfusion® Vue UI components

Dependencies

The following list of dependencies required to use the Timeline component in your application:

|-- @syncfusion/ej2-layouts
    |-- @syncfusion/ej2-base
|-- @syncfusion/ej2-vue-layouts
    |-- @syncfusion/ej2-vue-base

Setting up the Vue 2 project

To generate a Vue 2 project using Vue-CLI, use the vue create command. Follow these steps to install Vue CLI and create a new project:

npm install -g @vue/cli
vue create quickstart
cd quickstart
npm run serve

or

yarn global add @vue/cli
vue create quickstart
cd quickstart
yarn run serve

When creating a new project, choose the option Default ([Vue 2] babel, eslint) from the menu.

Vue 2 project

Once the quickstart project is set up with default settings, proceed to add Syncfusion® components to the project.

Add Syncfusion® Vue packages

Syncfusion® packages are available at npmjs.com. To use Vue components, install the required npm package.

This article uses the Vue Timeline component as an example. Install the @syncfusion/ej2-vue-layouts package by running the following command:

npm install @syncfusion/ej2-vue-layouts --save

or

yarn add @syncfusion/ej2-vue-layouts

Import Syncfusion® CSS styles

You can import themes for the Syncfusion® Vue component in various ways, such as using CSS or SASS styles from npm packages, CDN, CRG and Theme Studio. Refer to themes topic to know more about built-in themes and different ways to refer to themes in a Vue project.

In this article, the Material3 theme is applied using CSS styles, which are available in installed packages. The necessary Material3 CSS styles for the Timeline component and its dependents were imported into the <style> section of src/App.vue file.

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css';
</style>

Adding Syncfusion® Vue component

Follow the below steps to add the Vue Timeline component using Composition API or Options API:

1. First, import and register the Timeline component in the script section of the src/App.vue file. If you are using the Composition API, you should add the setup attribute to the script tag to indicate that Vue will be using the Composition API.

<script setup>
    import { TimelineComponent as EjsTimeline } from "@syncfusion/ej2-vue-layouts";
</script>
<script>
import { TimelineComponent } from "@syncfusion/ej2-vue-layouts";
export default {
    components: {
      'ejs-timeline': TimelineComponent
    }
}
</script>

2. In the template section, define the Timeline component.

<template>
  <ejs-timeline id="timeline"></ejs-timeline>
</template>

Adding items

You can use the <e-item> directive within the <e-items> directive to define each item.

<template>
  <ejs-timeline id="timeline">
      <e-items>
        <e-item></e-item>
        <e-item></e-item>
        <e-item></e-item>
        <e-item></e-item>
      </e-items>
  </ejs-timeline>
</template>

<script setup>
  import { TimelineComponent as EjsTimeline, ItemsDirective as EItems, ItemDirective as EItem  } from "@syncfusion/ej2-vue-layouts";
</script>
<template>
  <ejs-timeline id="timeline">
    <e-items>
      <e-item></e-item>
      <e-item></e-item>
      <e-item></e-item>
      <e-item></e-item>
    </e-items>
  </ejs-timeline>
</template>

<script>
import { TimelineComponent, ItemsDirective, ItemDirective } from "@syncfusion/ej2-vue-layouts";
export default {
    components: {
      'ejs-timeline': TimelineComponent,
      "e-items": ItemsDirective,
      "e-item": ItemDirective
    }
};
</script>

Here is the summarized code for the above steps in the src/App.vue file:

<template>
  <div class="container" style="height: 330px;margin-top: 30px;">
    <ejs-timeline id="timeline">
      <e-items>
        <e-item content='Shipped' />
        <e-item content='Departed' />
        <e-item content='Arrived' />
        <e-item content='Out for Delivery' />
      </e-items>
    </ejs-timeline>
  </div>
</template>
<script setup>
import { TimelineComponent as EjsTimeline, ItemsDirective as EItems, ItemDirective as EItem } from "@syncfusion/ej2-vue-layouts";

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
@import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
</style>
<template>
  <div class="container" style="height: 330px;margin-top: 30px;">
    <ejs-timeline id="timeline">
      <e-items>
        <e-item content='Shipped' />
        <e-item content='Departed' />
        <e-item content='Arrived' />
        <e-item content='Out for Delivery' />
      </e-items>
    </ejs-timeline>
  </div>
</template>
<script>
import { TimelineComponent, ItemsDirective, ItemDirective } from "@syncfusion/ej2-vue-layouts";
export default {
  name: "App",
  components: {
    'ejs-timeline': TimelineComponent,
    'e-items': ItemsDirective,
    'e-item': ItemDirective
  }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
@import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
</style>

Run the project

To run the project, use the following command:

npm run serve

or

yarn run serve

Getting started with Angular Timeline component

6 Feb 20267 minutes to read

This section explains how to create a simple Timeline and demonstrates the basic usage of the Timeline module in an Angular environment.

To get started quickly with Angular Timeline using CLI and Schematics, you can check this video:

Dependencies

The list of dependencies required to use the Timeline module in your application is given below:

@syncfusion/ej2-angular-layouts
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-layouts
    |-- @syncfusion/ej2-angular-base

Setup Angular Environment

You can use Angular CLI to setup your Angular applications.
To install Angular CLI use the following command.

npm install -g @angular/cli

Angular 21 Standalone Architecture: Standalone components are the default in Angular 21. This guide uses the modern standalone architecture. If you need more information about the standalone architecture, refer to the Standalone Guide.

Installing a specific version

To install a particular version of Angular CLI, use:

npm install -g @angular/[email protected]

Create a new application

With Angular CLI installed, execute this command to generate a new application:

ng new syncfusion-angular-app
  • This command will prompt you to configure settings like enabling Angular routing and choosing a stylesheet format.
? Which stylesheet format would you like to use? (Use arrow keys)
> CSS             [ https://developer.mozilla.org/docs/Web/CSS                     ]
  Sass (SCSS)     [ https://sass-lang.com/documentation/syntax#scss                ]
  Sass (Indented) [ https://sass-lang.com/documentation/syntax#the-indented-syntax ]
  Less            [ http://lesscss.org                                             ]
  • By default, a CSS-based application is created. Use SCSS if required:
ng new syncfusion-angular-app --style=scss
  • During project setup, when prompted for the Server-side rendering (SSR) option, choose the appropriate configuration.

Initial_setup

  • Select the required AI tool or ‘none’ if you do not need any AI tool.

Initial_setup

  • Navigate to your newly created application directory:
cd syncfusion-angular-app

Note: In Angular 19 and below, it uses app.component.ts, app.component.html, app.component.css etc. In Angular 20+, the CLI generates a simpler structure with src/app/app.ts, app.html, and app.css (no .component. suffixes).

Installing Syncfusion® Timeline Package

Syncfusion® packages are distributed in npm as @syncfusion scoped packages. You can get all the Angular Syncfusion® package from npm link.

Currently, Syncfusion® provides two types of package structures for Angular components:

  1. Ivy library distribution package format
  2. Angular compatibility compiler(Angular’s legacy compilation and rendering pipeline) package.

Ivy library distribution package

Syncfusion® Angular packages(>=20.2.36) has been moved to the Ivy distribution to support the Angular Ivy rendering engine and the package are compatible with Angular version 12 and above. To download the package use the below command.

Add @syncfusion/ej2-angular-layouts package to the application.

npm install @syncfusion/ej2-angular-layouts --save

Angular compatibility compiled package(ngcc)

For Angular version below 12, you can use the legacy (ngcc) package of the Syncfusion® Angular components. To download the ngcc package use the below.

Add @syncfusion/ej2-angular-layouts@ngcc package to the application.

npm install @syncfusion/ej2-angular-layouts@ngcc --save

To mention the ngcc package in the package.json file, add the suffix -ngcc with the package version as below.

@syncfusion/ej2-angular-layouts:"21.1.35-ngcc"

Note: If the ngcc tag is not specified while installing the package, the Ivy Library Package will be installed and this package will throw a warning.

Adding Timeline module

Import Timeline module into Angular application app.module.ts from the package @syncfusion/ej2-angular-layouts.

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

// Import Syncfusion Timeline module from Timeline package.
import { TimelineModule, TimelineAllModule } from '@syncfusion/ej2-angular-layouts';

import { AppComponent } from "./app.component";

@NgModule({
  imports: [BrowserModule, TimelineAllModule, TimelineModule], // Registering EJ2 Timeline Module.
  declarations: [AppComponent],
  bootstrap: [AppComponent],
})
export class AppModule {}

Adding CSS reference

Add Timeline component’s styles as given below in src/styles.css.

@import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
@import '../node_modules/@syncfusion/ej2-layouts/styles/material3.css';

Alternatively, based on the location of your CSS file, you can import the styles as shown below:

@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-layouts/styles/material3.css';

Adding Syncfusion® Timeline component

Modify the template in app.component.ts file with ejs-timeline to render the Timeline component.

import { TimelineModule, TimelineAllModule } from '@syncfusion/ej2-angular-layouts'
import { Component } from '@angular/core';

@Component({
    imports: [ TimelineModule, TimelineAllModule ],
    standalone: true,
    selector: "app-root",
    template: `<!-- To Render Timeline. -->
      <div>
          <ejs-timeline id="timeline"></ejs-timeline>
      </div>`,
  })
export class AppComponent {
}

Adding Items

You can define Timeline items by using <e-item> tag directive.

import { TimelineModule, TimelineAllModule } from '@syncfusion/ej2-angular-layouts'
import { Component } from '@angular/core';

@Component({
  imports: [ TimelineModule, TimelineAllModule ],
  standalone: true,
  selector: "app-root",
  template: `<!-- To Render Timeline. -->
    <div>
        <ejs-timeline id="timeline">
            <e-items>
                <e-item></e-item>
                <e-item></e-item>
                <e-item></e-item>
                <e-item></e-item>
            </e-items>
        </ejs-timeline>
    </div>`,
})
export class AppComponent {
}

Running the application

Run the application in the browser using the following command:

ng serve

The following example shows a default Timeline component.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TimelineModule, TimelineAllModule } from '@syncfusion/ej2-angular-layouts'
import { Component } from '@angular/core';

@Component({
    imports: [TimelineModule, TimelineAllModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
})
export class AppComponent {

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div class="container" style="height: 330px;margin-top: 30px;">
    <ejs-timeline id="timeline">
        <e-items>
            <e-item></e-item>
            <e-item></e-item>
            <e-item></e-item>
            <e-item></e-item>
        </e-items>
    </ejs-timeline>
</div>

Getting started with the React Timeline component

6 Feb 20267 minutes to read

This section explains how to create and configure a simple Timeline in a React application using Syncfusion Essential JS 2.

Dependencies

The following list of dependencies is required to use the Timeline component in the application.

|-- @syncfusion/ej2-react-layouts
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-layouts
    |-- @syncfusion/ej2-react-base

Installation and Configuration

To quickly set up a React application, use create-vite-app, which provides a faster development environment, smaller bundle sizes, and optimized builds compared to traditional tools like create-react-app. For detailed steps, refer to the Vite installation instructions. Vite configures the development environment using modern tooling and optimizes the application for production.

Note: To create a React application using create-react-app, refer to this documentation for more details.

To create a new React application, run the following command.

npm create vite@latest my-app

To set-up a React application in TypeScript environment, run the following command.

npm create vite@latest my-app -- --template react-ts
cd my-app
npm run dev

To set-up a React application in JavaScript environment, run the following command.

npm create vite@latest my-app -- --template react
cd my-app
npm run dev

Adding Syncfusion® packages

All the available Essential® JS 2 packages are published in npmjs.com public registry.

To install Timeline component, use the following command

npm install @syncfusion/ej2-react-layouts --save

Adding CSS Reference

Import the required CSS references for the Timeline component in src/App.css as shown below.

@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css";

Adding Timeline component to the application

To include the Timeline component in the application, import the TimelineComponent from the ej2-react-layouts package into the App.tsx file.

Each Timeline item is defined using the ItemDirective, which must be placed inside the ItemsDirective. The ItemsDirective acts as a container for managing multiple Timeline items, and each ItemDirective represents an individual entry in the Timeline.

import { TimelineComponent, ItemsDirective, ItemDirective } from '@syncfusion/ej2-react-layouts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import "./App.css";

function App() {
  return (
    <div id='timeline' style={{ height: "350px" }}>
      <TimelineComponent>
          <ItemsDirective>
              <ItemDirective />
              <ItemDirective />
              <ItemDirective />
              <ItemDirective />
          </ItemsDirective>
      </TimelineComponent>
    </div>
  );
}

const root = ReactDOM.createRoot(document.getElementById("element"));
root.render(<App />);

Running the application

Run the npm run dev command in the console to start the development server. This command compiles the application and serves it locally, making it available in the browser.

npm run dev

The following example shows a basic Timeline component.

import * as React from "react";
import * as ReactDom from "react-dom";
import { TimelineComponent, ItemsDirective, ItemDirective } from '@syncfusion/ej2-react-layouts';

function App() {
    return (
        <div id='timeline' style=>
            <TimelineComponent>
                <ItemsDirective>
                    <ItemDirective />
                    <ItemDirective />
                    <ItemDirective />
                    <ItemDirective />
                </ItemsDirective>
            </TimelineComponent>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById("element"));
import * as React from "react";
import * as ReactDom from "react-dom";
import { TimelineComponent, ItemsDirective, ItemDirective } from '@syncfusion/ej2-react-layouts';

function App() {
    return (
        <div id='timeline' style=>
            <TimelineComponent>
                <ItemsDirective>
                    <ItemDirective />
                    <ItemDirective />
                    <ItemDirective />
                    <ItemDirective />
                </ItemsDirective>
            </TimelineComponent>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById("element"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion EJ2 React Timeline Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='element' style="margin-top: 30px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>